#!/usr/bin/env python3
# -*- coding: utf-8 -*-


# FEATURES: os interface, system info, environment, lightweight process management
import os
import signal

print("\n### Basic system information")
print(f"Operating system simple name: \"{os.name}\"")


print("\n### Environment")
print(f"Environment as a map: \"{os.environ}\"")

print(f"Get env value for key \"foo\": \"{os.getenv('foo', 'default : foo not defined yet')}\"")
os.environ['foo'] = 'bar'

print(f"Get env value for key \"foo\" (1): \"{os.getenv('foo', 'default')}\"")
print(f"Get env value for key \"foo\" (2): \"{os.environ['foo']}\"")


print("\n### Process management")
print(f"Path where binaries are searched for: \"{os.get_exec_path()}\"")

print("Print current directory using call to external program")
if os.name == "posix":
    os.system("ls")
else:
    os.system("dir")

pid = os.getpid()
print(f"PID of the current process is {pid}")

print("Kill process using PID, kill this process")
os.kill(pid, signal.SIGINT)